% append0(L1, L2, L3): L1 s L2 listk egyms utn
% fzsvel ll el az L3 lista.
append0([], B, L) :-
    L = B.
append0([X|A], B, L) :-
    append0(A, B, C), L = [X|C].

% append(L1, L2, L3): L1 s L2 listk egyms utn
% fzsvel ll el az L3 lista.
append([], L, L).
append([X|A], B, [X|C]) :-
    append(A, B, C).

% append2(L1, L2, L3): L1 s L2 listk egyms utn
% fzsvel ll el az L3 lista.
append2([X|A], B, [X|C]) :-
    append2(A, B, C).
append2([], L, L).

