

(* szulei x = az x szemly szleinek listja*)
fun szulei "Imre"    = ["Istvn", "Gizella"] 
  | szulei "Istvn"  = ["Gza", "Sarolt"]
  | szulei "Gizella" = ["Civakod Henrik", "Burgundi Gizella"]
  | szulei _         = []    (* senki msnak nincs szlje *)

fun nagyszulei g = List.concat (map szulei (szulei g));

(* szulei_l lista = a lista-ban szerepl emberek szleinek listja*)
fun szulei_l ls = List.concat (map szulei ls)

fun nagyszulei1 gy = szulei_l (szulei gy)
fun nagyszulei2 gy = szulei_l (szulei_l [gy])

fun osei (0, gy) = [gy]
  | osei (n, gy) = szulei_l (osei (n-1, gy))

(* SML megolds: fakt n = n! *)
fun fakt 0 = 1
  | fakt n = n * fakt (n-1)


