balcsonk(node(leaf(V),_), V).
jobbcsonk(node(_,leaf(V)), V).

itree(leaf(V)) :-   
        integer(V).
itree(node(L,R)) :- 
        itree(L), itree(R).

fa_levele(leaf(V), V).
fa_levele(node(L,_), V) :- 
        fa_levele(L, V). 
fa_levele(node(_,R), V) :-
        fa_levele(R, V).


sum_tree(leaf(Value), Value).
sum_tree(node(Left,Right), S) :-
        sum_tree(Left, SL),
        sum_tree(Right, SR),
        S is SL+SR.
