jrat('Budapest', 'Prga', 515).
jrat('Budapest', 'Bcs', 245).
jrat('Bcs', 'Berlin', 635).
jrat('Bcs', 'Prizs', 1265).


% tszakasz(A, B, H): A-bl B-be eljuthatunk egy H thossz jrattal.
tszakasz(Kezdet, Cl, Tv) :-
     (   jrat(Kezdet, Cl, Tv)
     ;   jrat(Cl, Kezdet, Tv)
     ).

% tvonal(N, A, B, H): A s B kztt van (pontosan)
% N szakaszbl ll tvonal, amelynek sszhossza H.
tvonal(0, Kezdet, Kezdet, 0).
tvonal(N, Kezdet, Cl, H) :-
    N > 0,
    N1 is N-1,
    tszakasz(Kezdet, Kzben, H1),
    tvonal(N1, Kzben, Cl, H2),
    H is H1+H2.

